       ;Routine to create BUILD files. Can be used with
 ;Dos+ 3.4, TRSDOS, LDOS and NewDos 80, but was
 ;written mainly for NewDos 80 Version 2.0
 ;so the BUILD/BAS program could be deleted.
 ;<c> 1983 By Mel Patrick
 	ORG	5200H		;start of routine
 BUILD 	LD	DE,SAVE		;point to buffer
 	LD	A,(HL)		;get command input
 	CP	0DH		;any filename input?
 	JR	Z,DOBLD		;get filename later then
 BLD1	LD	A,(HL)		;else move name to buffer
 	LD	(DE),A		;now
 	INC	HL		;point to next character
 	INC	DE		;in buffer too
 	CP	0DH		;end of filename?
 	JR	NZ,BLD1		;loop til copied
 	LD	(NFLAG),A	;flag for name prompt
 DOBLD	CALL	01C9H		;clear the video
 	LD	HL,TITLE	;point to message
 	CALL	DISPLY		;show it on video
 	LD	B,63		;number for loop
 	LD	A,140		;graphics block
 GRLP	CALL	33H		;show line of them
 	DJNZ	GRLP		;loop til done
 	LD	HL,3F00H	;reset cursor location
 	LD	(4020H),HL	;for next line
 	LD	B,63		;number for loop
 GRLP1	LD	A,140		;graphics block
 	CALL	33H		;show it
 	DJNZ	GRLP1		;loop til done
 	LD	HL,BUFFER	;point to buffer
 INPUT	LD	(END),HL	;reset end to start
 	LD	HL,3F40H	;reset cursor location
 	LD	(4020H),HL	;to bottom of video
 	LD	HL,PROMPT	;point to message
 	CALL	DISPLY		;show it
 	LD	HL,(END)	;get end of buffer
 	LD	B,63		;bytes to input
 	CALL	40H		;get the input
 	JR	C,DONE		;go if break
 	LD	DE,3C80H	;destination of move
 	LD	HL,3CC0H	;one line below it
 	LD	BC,640		;area to move
 	LDIR			;and move it on video
 	LD	HL,3EC0H	;last line of text
 	LD	B,64		;bytes to erase
 ERASE	LD	(HL),20H	;space it out
 	INC	HL		;point to next
 	DJNZ	ERASE		;loop til cleared
 	LD	DE,3EC0H	;point to last line
 	LD	HL,(END)	;else get the start
 SCAN	LD	A,(HL)		;get a byte
 	CP	0DH		;end of input?
 	JR	Z,GOTEND	;go if found
 	LD	(DE),A		;move to bottom line
 	INC	DE		;point to next
 	INC	HL		;else point to next
 	JR	SCAN		;loop til done
 GOTEND	INC	HL		;point to new start
 	JR	INPUT		;and loop til break
 DONE	LD	(HL),0FFH	;set end of file
 	LD	(END),HL	;save last location
 	LD	A,(NFLAG)	;name already defined?
 	OR	A		;0=no else yes
 	JR	NZ,ALDONE	;go if already done
 	LD	HL,3F40H	;reset cursor location
 	LD	(4020H),HL	;on the screen
 	LD	HL,PROM		;point to filespec?
 	CALL	DISPLY		;show it
 	LD	HL,SAVE		;point to buffer
 	LD	B,20H		;bytes for filename
 	CALL	40H		;get the input
 	JP	C,402DH		;back to DOS if BREAK key
 ALDONE	LD	HL,DUMMY	;point to dummy buffer
 	LD	DE,SAVE		;point to filename
 	LD	B,00H		;set record length =256
 	CALL	4420H		;create or overwrite file
 	JR	NZ,ERROR	;go if error
 	LD	HL,BUFFER	;point to text area
 WRITE	LD	DE,SAVE		;point to filespec
 	LD	A,(HL)		;get a byte
 	CP	0FFH		;end of file?
 	JR	Z,CLOSE		;go if yes
 	CALL	1BH		;else write byte to disk
 	JP	NZ,ERROR	;go if write error
 	INC	HL		;point to next
 	LD	A,(3C3EH)	;get a byte
 	XOR	0AH		;toggle a *
 	LD	(3C3EH),A	;twinkle twinkle lil star
 	JR	WRITE		;loop til done
 CLOSE	LD	DE,SAVE		;point to filespec
 	CALL	4428H		;close file
 	JP	402DH		;and back to dos
 ERROR	SET	7,A		;set return route
 	LD	HL,3F40H	;reset cursor location
 	LD	(4020H),HL	;to show error message
 	PUSH	AF		;save error code
 	LD	A,1FH		;erase to end of frame
 	CALL	33H		;do it
 	POP	AF		;get code back now
 	CALL	4409H		;display the error
 	CALL	49H		;wait for any key
 	XOR	A		;remove filename flag
 	LD	(NFLAG),A	;reset the byte
 	LD	HL,(END)	;get last end address
 	JP	INPUT		;back to program input
 DISPLY	LD	A,(HL)		;get a byte
 	CP	03H		;end of msg
 	RET	Z		;back if yes
 	CALL	33H		;else show it
 	INC	HL		;point to next
 	JR	DISPLY		;loop til done
 TITLE	DEFM	'               Build File Utility Version 2.0'
 	DEFB	0DH
 	DEFB	03H
 PROMPT	DEFM	'Enter command (63 char. max), or <BREAK> to end'
 	DEFB	0EH		;turn on cursor
 	DEFB	0DH
 	DEFB	03H
 PROM	DEFB	0DH
 	DEFM	'Filespec for Save : '
 	DEFB	03H
 NFLAG	DEFB	00H		;filename prompt flag
 END	DEFW	0000H		;end address storage
 SAVE	DEFS	20H		;ASCII filename storage
 DUMMY	DEFS	256		;dummy buffer for output
 BUFFER	DEFB	00H		;start of text area
 	END	BUILD
